#!/bin/bash

set -eE -o pipefail
trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR


cur="$(host -4 b8.nz iankelling.org | sed -rn 's/.*has address (.*)/\1/p;T;q')"
ip=$(curl -s4 https://iankelling.org/cgi/pubip)

# note, a simpler way to do this would be to ssh and use
# "${SSH_CLIENT%% *}
# to update bind if needed.

if [[ $cur != $ip ]]; then
    nsupdate -k /p/c/machine_specific/li/filesystem/etc/bind/Kb8.nz.*.private <<EOF
server iankelling.org
zone b8.nz
update delete b8.nz. A
update add b8.nz. 300 A $ip
update delete *.b8.nz. A
update add *.b8.nz. 300 A $ip
show
send
EOF
fi

# # persistent initial setup for this:
# # create files in /a/c/machine_specific/li/filesystem/etc/bind
# # note, conflink also does some group ownership stuff.

# mkc /p/c/machine_specific/li/filesystem/etc/bind
# s dnssec-keygen -a HMAC-MD5 -b 512 -n HOST b8.nz
# s chown $USER:$USER *

# f=key.b8.nz
# cat >$f <<EOF
# key b8.nz. {
# algorithm HMAC-MD5;
# secret "$(awk '$1 == "Key:" {print $2}' Kb8.nz.*.private)";
# };
# EOF

# chmod 640 [kK]*

# myunison -ob li
# ssh li conflink
# ssh li ser restart bind9
